open GridSolve;;

let sutton = 
[| 
[| Full; Full ; Full ; Full ; Full ; Full ; Full ; Full ; Full ; Full ; Full|];
[| Full; Empty; Empty; Empty; Empty; Empty; Empty; Empty; Full ; Goal ; Full|];
[| Full; Empty; Empty; Full ; Empty; Empty; Empty; Empty; Full ; Empty; Full|];
[| Full; Empty; Empty; Full ; Empty; Empty; Empty; Empty; Full ; Empty; Full|];
[| Full; Empty; Empty; Full ; Empty; Empty; Empty; Empty; Empty; Empty; Full|];
[| Full; Empty; Empty; Empty; Empty; Empty; Full ; Empty; Empty; Empty; Full|];
[| Full; Empty; Empty; Empty; Empty; Empty; Empty; Empty; Empty; Empty; Full|];
[| Full; Full ; Full ; Full ; Full ; Full ; Full ; Full ; Full ; Full ; Full|]
|];;


let boolOfInt =fun b -> match b with
  | true -> 1
  | false -> 0 ;;

let makeStateFromString = fun thisString -> 
  Scanf.sscanf thisString "%i %i" (fun potposx potposy -> (potposx, potposy));;

let makeActionFromString = fun thisString -> 
  Scanf.sscanf thisString "%i %i" (fun potposx potposy -> (potposx -1, potposy -1));;

let makeStringFromState = fun (potposx, potposy) ->
  Printf.sprintf "%i %i" potposx potposy ;;

let makeStringOfObs = fun obs -> 
  Printf.sprintf "%i %i %i %i" (boolOfInt obs.up) 
  (boolOfInt obs.down)  (boolOfInt obs.left) (boolOfInt obs.right);;

(*Printf.fprintf stderr "Caml demo program for Sutton's maze \n";;*)

let safe_read_line _ = 
  try
    read_line()
  with
    End_of_file -> exit 0;;

let grid = sutton in
output_string stdout "actions: {0,2}x{0,2}\n";
let state = ref ""
and seed = ref ""
and action = ref "" in
while true do
  begin 
    match !seed with
      "" -> ()
    | s -> Random.init (int_of_string s)
  end;
  let new_obs, new_reward, new_state = 
    match !state with
      | "" -> 
	  let state = sampleState grid in
	  makeStringOfObs (gridCellToObs grid state),
	  string_of_float (1. +. rewardPos grid state),
	  makeStringFromState state
      | _ -> 
	  let currState = makeStateFromString !state in
	  let action = makeActionFromString !action in
	  let state = detTran grid currState action in
	  makeStringOfObs (gridCellToObs grid state),
	  string_of_float (1. +. rewardPos grid state),
	  makeStringFromState state in
  Printf.printf "%s\n%s\n%s\n" new_obs new_reward new_state;
  flush stdout;
  state  := safe_read_line ();
  seed   := safe_read_line ();
  action := safe_read_line ()
done;;


