

let inner_prod = fun x y ->
  (Myarray.fold_left ( ( +. ) )  (0.0)
      (Myarray.map2 (( *. )) x y )
   )

let list_inner_prod = fun x y ->
  (List.fold_left ( ( +. ) )  (0.0)
      (List.map2 (( *. )) x y )
   )


let distanceSquared x1 x2= 
  let diff = Myarray.map2 (-.) x1 x2 in
  inner_prod diff diff

(*let bandwidth = 0.05 *)
let bandwidth = 0.15

let gaussKernel = fun c1 c2 ->
  let dS = distanceSquared c1 c2 in
  exp( -1.0 *. ( dS) /. (bandwidth ** 2.0 ) )

let kernelFun = fun states stateWeights -> fun c ->
  let kernc = gaussKernel c in  
  let kernelComputations = List.map (kernc) states in 
  list_inner_prod kernelComputations stateWeights  

