
(*module Myarray = struct *)
include Array;;


(* A wrapping get function *)
let wget = fun array pos -> 
  match pos with
  | _ when (pos >= 0 & pos < Array.length array ) -> Array.get array pos
  | _ when pos < 0 -> Array.get array (Array.length array + pos )  
  | _ -> Array.get array (pos - Array.length array )  

let map2 f a b  =
  let l = Array.length a in
  if l = 0 then [||] else begin
    let r = Array.create l (f (Array.unsafe_get a 0) (Array.unsafe_get b 0) ) in
    for i = 1 to l - 1 do
      Array.unsafe_set r i (f (Array.unsafe_get a i) (Array.unsafe_get b i))
    done;
    r
  end
;;
let fold_lefti f x a =
  let r = ref (0,x) in
  for i = 0 to Array.length a - 1 do
    r := f !r (i ,(Array.unsafe_get a i)) 
  done;
  !r 

(*Only apply to list having length 2 or more!! *)
let fold_left_noinit_i f a =
  let r = ref (0,(Array.unsafe_get a 0)) in
  for i = 1 to Array.length a - 1 do
    r := f !r (i ,(Array.unsafe_get a i)) 
  done;
  !r



(*end*)
