#include "newmatap.h"                // need matrix applications
#ifdef use_namespace
using namespace NEWMAT;              // access NEWMAT namespace
#endif
#include <math.h>
#include "game.h"
#include <iostream.h>
#include "newmatio.h"
#include "newmatap.h"


//Colors!
const int c1 =1;
const int c2 =2;
const int c3 =3;
const int c4 =4;
const int c5 =5;
const int c6 =6;
const int c7 =7;

Game::Game() {
  Matrix x(height,width);x=0;
  ColumnVector phi(fnum);phi=0;
  phi(fnum)=1;
  int object=rand()%7+1;
  state.x=x;
  state.phi=phi;
  state.r=0;
  state.object=object;
  state.over=0;
  start_state=state;
}

state_var Game::action(control_var control) const {
  state_var next={state.x,state.phi,0,0,0};
  int p=control.p;
  int r=control.r;
  
  if (state.object==1){
    //the square
    int h=max(next.phi,p,p+1);
    next.x(h+1,p)=c1;
    next.x(h+1,p+1)=c1;
    next.x(h+2,p)=c1;
    next.x(h+2,p+1)=c1;
    state_update(next);
  }
  else if (state.object==2){
    //the line (vertical start)
    if (r==1||r==3){
      next.x(next.phi(p)+1,p)=c2;
      next.x(next.phi(p)+2,p)=c2;
      next.x(next.phi(p)+3,p)=c2;
      next.x(next.phi(p)+4,p)=c2;}
    else {
      int h=max(next.phi,p,p+3);
      next.x(h+1,p)=c2;
      next.x(h+1,p+1)=c2;
      next.x(h+1,p+2)=c2;
      next.x(h+1,p+3)=c2;}
    state_update(next);
  }
  else if (state.object==3){
    //zigzag with left higher (horizontal start)
    if (r==1||r==3){
      --next.phi(p);
      int h=max(next.phi,p,p+2);
      ++next.phi(p);
      next.x(h+2,p)=c3;
      next.x(h+2,p+1)=c3;
      next.x(h+1,p+1)=c3;
      next.x(h+1,p+2)=c3;}
    else {
      --next.phi(p+1);
      int h=max(next.phi,p,p+1);
      ++next.phi(p+1);
      next.x(h+1,p)=c3;
      next.x(h+2,p)=c3;
      next.x(h+2,p+1)=c3;
      next.x(h+3,p+1)=c3;}
    state_update(next);
  }
  else if (state.object==4){
    //zigzag with right higher (horizontal start)
    if (r==1||r==3){
      --next.phi(p+2);
      int h=max(next.phi,p,p+2);
      ++next.phi(p+2);
      next.x(h+1,p)=c4;
      next.x(h+1,p+1)=c4;
      next.x(h+2,p+1)=c4;
      next.x(h+2,p+2)=c4;}
    else {
      --next.phi(p);
      int h=max(next.phi,p,p+1);
      ++next.phi(p);
      next.x(h+2,p)=c4;
      next.x(h+3,p)=c4;
      next.x(h+1,p+1)=c4;
      next.x(h+2,p+1)=c4;}
    state_update(next);
  }
  else if (state.object==5){
    // this is L
    if (r==1){
      int h=max(next.phi,p,p+1);
      next.x(h+1,p)=c5;
      next.x(h+1,p+1)=c5;
      next.x(h+2,p)=c5;
      next.x(h+3,p)=c5;}
    else if (r==2){
      ++next.phi(p);
      int h=max(next.phi,p,p+2);
      --next.phi(p);
      next.x(h,p)=c5;
      next.x(h+1,p)=c5;
      next.x(h+1,p+1)=c5;
      next.x(h+1,p+2)=c5;}
    else if (r==3){
      next.phi(p+1)+=2;
      int h=max(next.phi,p,p+1);
      next.phi(p+1)-=2;
      next.x(h+1,p)=c5;
      next.x(h+1,p+1)=c5;
      next.x(h-1,p+1)=c5;
      next.x(h,p+1)=c5;}
    else {
      int h=max(next.phi,p,p+2);
      next.x(h+1,p)=c5;
      next.x(h+1,p+1)=c5;
      next.x(h+1,p+2)=c5;
      next.x(h+2,p+2)=c5;}
    state_update(next);
  }
  else if (state.object==6){
    // the BACK L
    if (r==1){
      int h=max(next.phi,p,p+1);
      next.x(h+1,p)=c6;
      next.x(h+1,p+1)=c6;
      next.x(h+2,p+1)=c6;
      next.x(h+3,p+1)=c6;}
    else if (r==2){
      int h=max(next.phi,p,p+2);
      next.x(h+1,p)=c6;
      next.x(h+1,p+1)=c6;
      next.x(h+1,p+2)=c6;
      next.x(h+2,p)=c6;}
    else if (r==3){
      next.phi(p)+=2;
      int h=max(next.phi,p,p+1);
      next.phi(p)-=2;
      next.x(h+1,p)=c6;
      next.x(h+1,p+1)=c6;
      next.x(h-1,p)=c6;
      next.x(h,p)=c6;}
    else {
      ++next.phi(p+2);
      int h=max(next.phi,p,p+2);
      --next.phi(p+2);
      next.x(h,p+2)=c6;
      next.x(h+1,p)=c6;
      next.x(h+1,p+1)=c6;
      next.x(h+1,p+2)=c6;}
    state_update(next);
  }
  else {
    //finally the T-bone (horizontal, pointing up start)
    if (r==1){
      int h=max(next.phi,p,p+2);
      next.x(h+1,p)=1;
      next.x(h+1,p+1)=1;
      next.x(h+1,p+2)=1;
      next.x(h+2,p+1)=1;}
    else if (r==2){
      --next.phi(p+1);
      int h=max(next.phi,p,p+1);
      ++next.phi(p+1);
      next.x(h+1,p)=1;
      next.x(h+2,p)=1;
      next.x(h+3,p)=1;
      next.x(h+2,p+1)=1;}
    else if (r==3){
      ++next.phi(p+1);
      int h=max(next.phi,p,p+2);
      --next.phi(p+1);
      next.x(h+1,p)=1;
      next.x(h+1,p+1)=1;
      next.x(h+1,p+2)=1;
      next.x(h,p+1)=1;}
    else {
      --next.phi(p);
      int h=max(next.phi,p,p+1);
      ++next.phi(p);
      next.x(h+2,p)=1;
      next.x(h+1,p+1)=1;
      next.x(h+2,p+1)=1;
      next.x(h+3,p+1)=1;}
    state_update(next);
  }

  next.object=rand()%7+1;
  return next;
}

int Game::max(ColumnVector phi,int start,int finish) const
{
  int m=0;
  for (int i=start;i<=finish;i++){
    if (phi(i)>m)
      m=phi(i);
  };
  return m;
}

int isFull(state_var & next,int r,int c) {
    if (next.x(r,c) > 0)
        return 1;
    else
        return 0;
}


//state-update computes the collapse of rows
//and resulting phi vector

void Game::state_update(state_var & next) const
{
  ColumnVector full(height);full=0;
  next.r=0;
  
  for (int r=1;r<=height;r++) {
    for (int c=1;c<=width;c++)
        //full(r)+=next.x(r,c);
        full(r)+=isFull(next,r,c);
  }
  
  for (int i=end_height;i>=1;i--)
    if (full(i)==width) {
      for (int c=1;c<=width;c++){
	next.x(height,c)=0;
	for (int r=i;r<=(height-1);r++)
	  next.x(r,c)=next.x(r+1,c);
      }
      ++next.r;
    } 

  state_rep(next);
  return;
}

void Game::state_rep(state_var & next) const
{
  ColumnVector phi(fnum);phi=0;
  phi(fnum)=1;
  // 1-10 heigts, 11-19 diffs, 20 max, 21 holes, 22 bias
  double height_sum=0;
  double filled_sum=0;
  for (int c=1;c<=width;++c){
    for (int r=1;r<=height;++r){
        //if (next.x(r,c)==1){ //JAB modify
        if (isFull(next,r,c)){ //JAB modify
	// setting the heights,max,and above ??end_height?? feature
	phi(c)=r;
	if (r>phi(20))
	  phi(20)=r;
	if (r>=end_height)
	  next.over=1;
	  ++filled_sum;
      }
    }
    height_sum+=phi(c);
  }
  phi(21)=height_sum-filled_sum;  
  for (int c=11;c<=19;++c)
    phi(c)=fabs(phi(c-10)-phi(c-9)); //changed from abs!!
  
  next.phi=phi;
  return;
}

	 

