#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <limits.h>
#include <iostream.h>
#include "newmatio.h"
#include "newmatap.h"
#include "include.h"
#include <fstream>
#include <sstream>

#include "newmat.h"
#include "newmatio.h"
#include "newmatrc.h"


#ifdef use_namespace
using namespace NEWMAT;              // access NEWMAT namespace
#endif
#include <math.h>
#include "game.h"

//outputfile streams we'll need

Matrix final_p(7,4);
Real a[] = {
  9,0,0,0,
  10,7,0,0,
  7,9,0,0,
  7,9,0,0,
    9,8,9,8,
  9,8,9,8,
  8,9,8,9,};

ofstream movie;
ofstream progress;

ostream& flatPrint(ostream& s, const GeneralMatrix& X)
{
   MatrixRow mr((GeneralMatrix*)&X, LoadOnEntry);
   int w = s.width();  int nr = X.Nrows();  ios_format_flags f = s.flags();
   s.setf(ios::fixed, ios::floatfield);
   //s << "[ \n";
   for (int i=1; i<=nr; i++)
   {
      int skip = mr.skip;  int storage = mr.storage;
      Real* store = mr.data;  skip *= w+1;
      while (skip--) s << " ";
      while (storage--) { s.width(w); s << *store++ << " "; }
//      while (storage--) s << setw(w) << *store++ << " ";
      mr.Next(); s << " "; //s << "; \n";
   }
   //s << "]\n";
   //s << " "; 
   s << flush;  s.flags(f); return s;
}

istream& flatRead(istream& s, GeneralMatrix& X)
{
   MatrixRow mr((GeneralMatrix*)&X, LoadOnEntry);
   int w = s.width();  int nr = X.Nrows();  ios_format_flags f = s.flags();
   s.setf(ios::fixed, ios::floatfield);
   //s << "[ \n";
   for (int i=1; i<=nr; i++)
   {
      int skip = mr.skip;  int storage = mr.storage;
      Real* store = mr.data;  skip *= w+1;
      while (skip--) ; //s << " ";
      while (storage--) { s.width(w); s >> *store++; }
//      while (storage--) s << setw(w) << *store++ << " ";
      mr.Next(); //s << " "; //s << "; \n";
   }
   //s << "]\n";
   //s << " "; 
   //s << flush;  
   s.flags(f); return s;
}

int frameIndex=1;

void 
standardDisplay(Game & tetris) {
  //observation,reward,state
  state_var state=tetris.give_state();

  //for movie....
  movie << "GameMove(:,:,"<< frameIndex <<") = " << state.x <<endl; 
  movie.flush();
  frameIndex++;


  flatPrint(cout , state.phi) << endl;
  cout << state.r/end_height << endl;
  flatPrint(cout,state.x) << state.object  << endl ;
}

void
standardInteract(Game & tetris) {

  //state 
  //If this is not an information request (i.e. state is blank, as possibly are actions)

  if (!(cin.peek() == '\n')) {

    Matrix x(height,width); 
    //Matrix x(2,2);
    flatRead(cin,x);
    progress << "Got Matrix\n";
    flush(progress);

    int object;
    cin >> object;
    object++; //To deal with fact interace standard goes 0-#actions-1
    progress << "Got Object " << object << endl;
    flush(progress);    

    state_var temp;
    temp.x = x;
    temp.object = object;
    temp.over = 0;
    temp.r = 0;
    
    //progress << temp.x;;
    //Make state make sense...
    tetris.state_update(temp);
    tetris.state = temp;
    
    //progress << tetris.state.x;;

    cin.ignore();

    int seed;
    string seedString;
    getline(cin,seedString); //state
    if(seedString=="\n") {
      seed = rand();
    }
    else {
      stringstream strStream(seedString,(stringstream::in | stringstream::out));
      strStream >> seed;
    }
    progress << "Got seed " << seed <<endl ;
    flush(progress);
    srand(seed);
    
    
    int p,r; //action
    cin >> p >> r;
    control_var  control = {p,r};
    progress << "Got action  " << p <<" "<< r << endl;
    flush(progress);
    
    //Extract the newline off the end
    cin.ignore();

    if (!temp.over) {
      
      if(p<=final_p(tetris.state.object,r)) {
	tetris.advance_game(control);
      } 
      else {
	progress << "This worries me" << endl;
	tetris.advance_game(control);
      }
      
      progress << "Computed next state" << endl;
      standardDisplay(tetris);
      
    }
    else {
      progress << "Game is over!" << endl;
      standardDisplay(tetris);
    }
  }
  else {
    progress << "Information request" << endl;
    string dummy;
    getline(cin,dummy); //state
    getline(cin,dummy); //seed
    getline(cin,dummy); //action

    state_var state=tetris.reset_game();
    standardDisplay(tetris);
  }
  //flatPrint(progress,x);

}

int main(void) {

  Game tetris;
  bool max_act;

  //load up the final positions that are legals
  final_p<<a;

  state_var state=tetris.reset_game();
  
  movie.open("gamemovie.m");
  progress.open("progress.txt");

  cout << "actions: {0," << width << "}x{0,4}\n";

  standardDisplay(tetris);
  while(1) {
  standardInteract(tetris);
  movie.flush();
  progress.flush();
  }
  return(0);

}
