let classifier = ref ""

let safe_read_line _ = 
  try
    read_line()
  with
    End_of_file -> 
      exit 0

let _ = 
  try
    Recursive_arg.parse [] (fun x -> classifier := x) "usage: debug_io program";
    
    let (ci,co) = Unix.open_process !classifier in
    Unix.set_close_on_exec (Unix.descr_of_out_channel co);
    Unix.set_close_on_exec (Unix.descr_of_in_channel ci);
    
    let first_space = String.index !classifier ' ' in
    let prog_name = String.sub !classifier 0 first_space in
    
    let actions = input_line ci in
    output_string stderr (prog_name^" output: "^actions^"\n");
    flush stderr;
    output_string stdout (actions^"\n");
    flush stdout;
    
    while true do
      let state = safe_read_line () in
      let action = safe_read_line () in
      output_string stderr (prog_name^" input features: "^state^"\n");
      output_string stderr (prog_name^" input action: "^action^"\n");
      flush stderr;
      output_string co (state^"\n");
      output_string co (action^"\n");
      flush co;
      let obs = input_line ci in
      let reward = input_line ci in
      let state = input_line ci in
      output_string stderr (prog_name^" output observation: "^obs^"\n");
      output_string stderr (prog_name^" output reward: "^reward^"\n");
      output_string stderr (prog_name^" output state: "^state^"\n");
      flush stderr;
      output_string stdout (obs^"\n");
      output_string stdout (reward^"\n");
      output_string stdout (state^"\n");
      flush stdout;
    done 
  with f -> 
    output_string stderr "debug_g: ";
    raise f
