let generative_from_deterministic_generative deterministic_generative state action = 
  let (observation, reward, state, seed) = deterministic_generative state "" action in
  (observation, reward, state)
    
let trace_from_generative generative policy timesteps = 
  let (observation, reward, state) = generative "" "" in
  let current_state = ref state in
  let current_observation = ref (observation,reward) in
  for t = 1 to timesteps do
    let action = policy !current_observation in
    let (next_obs, next_reward, next_state) = generative state action in
    current_observation := (next_obs,next_reward);
    current_state := next_state;
  done

let io_deterministic_generative deterministic_generative =
  while true do
    let state = read_line ()
    and seed = read_line () 
    and action = read_line () in
    let (observation, reward, state, seed) = deterministic_generative state seed action in
    print_string (observation^"\n"^reward^"\n"^state^"\n"^seed^"\n");
  done

let io_generative generative =
  while true do
    let state = read_line ()
    and action = read_line () in
    let (observation, reward, state) = generative state action in
    print_string (observation^"\n"^reward^"\n"^state^"\n");
  done

let io_policy (observation, reward) = 
  print_string (observation^"\n"^reward^"\n");
  read_line ()

let io_trace trace = trace io_policy
